from typing import List

from ci_autoupdate.git.actor import GitRepoInterface
from ci_autoupdate.tool_logging import AutoUpdateEvent, AutoUpdateEventResult, AutoUpdateLogger


class MergeRequestPreparationResult:
    def __init__(self, branch_result: bool, commit_result: bool, push_result: bool):
        self.branch_result = branch_result
        self.commit_result = commit_result
        self.push_result = push_result


class Coordinator:
    def __init__(
        self,
        cloned_project_labels: List[str],
        git_actor: GitRepoInterface,
        target_ci_version: str,
        new_branch_name: str,
        logger: AutoUpdateLogger = None,
    ):
        self.cloned_project_labels = cloned_project_labels
        self.git_actor = git_actor
        self.target_ci_version = target_ci_version
        self.new_branch_name = new_branch_name
        self.logger = logger

    def prep_merge_request(self) -> MergeRequestPreparationResult:
        commit_result = False
        push_result = False
        # Check out new branch in repo
        branch_result = self.try_checkout_new_branch()
        if not branch_result:
            return MergeRequestPreparationResult(branch_result, commit_result, push_result)
        # Commit changes
        commit_result = self.try_commit_changes()
        if not commit_result:
            return MergeRequestPreparationResult(branch_result, commit_result, push_result)
        # Push new branch
        push_result = self.try_push_changes()
        return MergeRequestPreparationResult(branch_result, commit_result, push_result)

    def try_checkout_new_branch(self) -> bool:
        # Checking out a new branch can fail with exception; handle here or in actor
        try:
            self.git_actor.checkout_new_branch(self.new_branch_name)
            self.log_branch_success(self.new_branch_name)
            return True
        except Exception as ex:
            self.log_branch_failure(self.new_branch_name, ex.__str__())
            return False

    def try_commit_changes(self) -> bool:
        commit_msg = (
            f"Bumping CI template dependencies to {self.target_ci_version}\n\nGenerated by the ci-autoupdate tool."
        )
        # Committing changes can fail with exception; handle here or in actor
        try:
            self.git_actor.commit_changes(commit_msg)
            self.log_commit_success(commit_msg)
            return True
        except Exception as ex:
            self.log_commit_failure(ex.__str__())
            return False

    def try_push_changes(self) -> bool:
        # Pushing changes can fail with exception; handle here or in actor (currently unimplemented)
        try:
            self.git_actor.push()
            self.log_push_success()
            return True
        except Exception as ex:
            self.log_push_failure(ex.__str__())
            return False

    def log_branch_success(self, branch_name: str):
        if self.logger is not None:
            self.logger.log_info(
                f"Successfully created branch {branch_name} for project at {str(self.git_actor.path().absolute())}",
                AutoUpdateEvent.BRANCH_CREATION,
                AutoUpdateEventResult.SUCCESS,
            )

    def log_branch_failure(self, branch_name: str, error_msg: str):
        if self.logger is not None:
            self.logger.log_error(
                f"Failed to created branch {branch_name} for project at {str(self.git_actor.path().absolute())}!  The remaining git operations for this project will be skipped!  Error message: {error_msg}",  # noqa
                AutoUpdateEvent.BRANCH_CREATION,
                AutoUpdateEventResult.FAILURE,
            )

    def log_commit_success(self, commit_msg: str):
        if self.logger is not None:
            self.logger.log_debug(
                f"Project at {str(self.git_actor.path().absolute())}  ommit message used: {commit_msg}",
                AutoUpdateEvent.CHANGESET_COMMIT,
            )
            self.logger.log_info(
                f"Successfully commited for project at {str(self.git_actor.path().absolute())}",
                AutoUpdateEvent.CHANGESET_COMMIT,
                AutoUpdateEventResult.SUCCESS,
            )

    def log_commit_failure(self, error_msg: str):
        if self.logger is not None:
            self.logger.log_error(
                f"Failed to commit changes to project at {str(self.git_actor.path().absolute())}!  The remaining git operations for this project will be skipped!  Error message: {error_msg}",  # noqa
                AutoUpdateEvent.CHANGESET_COMMIT,
                AutoUpdateEventResult.FAILURE,
            )

    def log_push_success(self):
        if self.logger is not None:
            self.logger.log_info(
                f"Successfully pushed to remote the project at {str(self.git_actor.path().absolute())}",
                AutoUpdateEvent.BRANCH_PUSH,
                AutoUpdateEventResult.SUCCESS,
            )

    def log_push_failure(self, error_msg: str):
        if self.logger is not None:
            self.logger.log_error(
                f"Failed to push to remote the project at {str(self.git_actor.path().absolute())}!  The remaining MR creation for this project will be skipped!  Error message: {error_msg}",  # noqa
                AutoUpdateEvent.BRANCH_PUSH,
                AutoUpdateEventResult.FAILURE,
            )
